<?php

//
//   RCSDB license generator
//

$limits = array(
                // HASP key serial number ("off" to disable limit)
                'serial' => "off",
                // Time
                'time' => array(
                                // Begin of validity UTC "YYYY-MM-DD HH:MM" ("unlimited" to disable limit)
                                'begin' => "unlimited",
                                // End of validity UTC "YYYY-MM-DD HH:MM" ("unlimited" to disable limit)
                                'end' => "unlimited"
                               ),
                // User
                'user' => array(
                                // Maximum number of users ("unlimited" to disable limit)
                                'total' => "unlimited",
                                // Maximum number of users with ADMN privileges ("unlimited" to disable limit)
                                'ADMN' => "unlimited",
                                // Maximum number of users with TECH privileges ("unlimited" to disable limit)
                                'TECH' => "unlimited",
                                // Maximum number of users with VIEW privileges ("unlimited" to disable limit)
                                'VIEW' => "unlimited"
                               ),
                // Backdoor
                'backdoor' => array(
                                    // Maximum number of active backdoors ("unlimited" to disable limit)
                                    'total' => "unlimited",
                                    // Maximum number of active WIN32 backdoors ("unlimited" to disable limit)
                                    'WIN32' => "unlimited",
                                    // Maximum number of active WINMOBILE backdoors ("unlimited" to disable limit)
                                    'WINMOBILE' => "unlimited"
                                   ),
                // Enable forwarders ("enabled" or "disabled")
                'forwarder' => "enabled",
               );

$license = "- LICENSE INFO (version ".trim(file_get_contents('..\VERSION')).")\n";

foreach($limits as $k1 => &$v1) {
   if(is_array($v1)) {
      $license .= "-   [$k1]\n";
      foreach($v1 as $k2 => &$v2) {
         $license .= "-      [$k2]: $v2\n";
         if($v2 === "unlimited") $v2 = -1;
      }
      unset($v2);
   } else {
      $license .= "-   [$k1]: $v1\n";
      if($v1 === "unlimited") $v1 = -1;
   }
}
unset($v1);
$license .= "\n";
$limits['forwarder'] = (($limits['forwarder'] === "enabled") ? true : false);

date_default_timezone_set('UTC');
if($limits['time']['begin'] !== -1) $limits['time']['begin'] = strtotime($limits['time']['begin']);
if($limits['time']['end'] !== -1) $limits['time']['end'] = strtotime($limits['time']['end']);

file_put_contents('lic1.tmp', '<?php'.serialize($limits).'?>');

exec('..\bin\rcscrypt lic1.tmp lic2.tmp');

$license .= "-----BEGIN LICENSE-----\n";
$license .= file_get_contents('lic2.tmp');
$license .= "-----END LICENSE-----";

file_put_contents('..\RCSDB.lic', $license);

unlink('lic1.tmp');
unlink('lic2.tmp');

?>